c       VERSION 1.0     12/17/88
c**********************************************************************
c
c       This subroutine calculates the xlk coefficients for
c       the potential dependent part of the diffusion operator
c       in matrll.
c
c       Notes:
c               This routine is essentially a copy of a section of
c               code from the subroutine matr written by G. Moro.
c
c       written by DJS 27-JUN-84
c
c       Includes:
c               rndoff.inc
c               eprdat.inc
c
c       Uses:
c               w3j.f
c
c**********************************************************************
c
      subroutine calxlk(rx,rz)
c
      implicit none
c
      include 'rndoff.inc'
      include 'eprdat.inc'
c
      double precision rx,rz
c
      integer i,j,k,l,kptf,kpti,k1f,k1i,k1,l1,l2,k1abs,
     #     kk1,k2,k2abs,kk2,ll1,ll,kk,ll2
      double precision factl,wig1,xxx,xxx2,xxx3,rdiff
c
      double precision w3j
      external w3j
c
c######################################################################
c
      rdiff=rz-rx
c
      do 100 j=1,5
        do 110 i=1,5
          xlk(i,j)=0.0D0
 110    continue
 100  continue
c
        xxx=0.0D0
c
c----------------------------------------------------------------------
c     exit if no potential
c----------------------------------------------------------------------
c
      if(ipt.eq.0) go to 9999
c
c---------------------------------------------------------------------
c     calculate xlk coefficients
c----------------------------------------------------------------------
c
      do 300 l=0,lptmx*2,2
        ll=1+l/2
        factl=dble(2*l+1)
        if (l.lt.kptmx*2) then
          kptf=l
        else
          kptf=kptmx*2
        end if
        kpti=0
        do 310 k=kpti,kptf,2
          kk=1+k/2
          xlk(ll,kk)=-0.5D0*cpot(ll,kk)*
     #               (rx*(l*(l+1))+rdiff*(k*k))
          xxx=0.0D0
          do 320 l1=0,lptmx,2
            ll1=1+l1/2
            if (l1.lt.kptmx) then
              k1f=l1
            else
              k1f=kptmx
            end if
            k1i=-k1f
            do 330 l2=0,lptmx,2
              ll2=1+l2/2
              if(l1+l2.ge.l) then
                wig1=w3j(l1,l,l2,0,0,0)
              else
                wig1=0.0D0
                go to 330
              end if
              do 340 k1=k1i,k1f,2
                k1abs=abs(k1)
                kk1=1+k1abs/2
                k2=k-k1
                k2abs=abs(k2)
                kk2=1+k2abs/2
                if((abs(k1+1).le.l1).and.(abs(k2-1).le.l2)) then
                  xxx2=rx*w3j(l1,l,l2,k1+1,-k,k2-1)*
     #                 dsqrt(dble((l1-k1)*(l1+k1+1)*(l2+k2)*(l2-k2+1)))
                else
                  xxx2=0.0D0
                end if
                if(k2abs.le.l2) then
                  xxx3=rz*dble(k1*k2)*w3j(l1,l,l2,k1,-k,k2)
                else
                  xxx3=0.0D0
                end if
c
                xxx=xxx+cpot(ll1,kk1)*cpot(ll2,kk2)*wig1*(xxx2+xxx3)
c
 340          continue
 330        continue
 320      continue
          xlk(ll,kk)=xlk(ll,kk)-0.25D0*factl*xxx
 310    continue
 300  continue
c
      do 400 ll=1,5
        do 410 kk=1,5
          if (abs(xlk(ll,kk)).lt.rndoff) xlk(ll,kk)=0.0D0
 410    continue
 400  continue
c
c----------------------------------------------------------------------
c     return to caller
c----------------------------------------------------------------------
c
 9999 return
      end
