c**********************************************************************
c
c                       ================
c                       program FMATRX
c                       ================
c
c       This program will read in the matrix data file written by
c       the main calculation programs eprcgf, eprlf, eprlcg and epresa.
c       Write it to the screen in an understandable form.
c
c       written by DEB 19-MAR-92 based on MATLST by DJS 29-SEP-87
c
c       Includes:
c               stddim.inc
c               stdio.inc
c               eprmat.inc
c               eprdat.inc
c               indexf.inc
c               fnames.inc
c
c       Uses:
c               getids.f
c               setnam.f
c               rdfdat.f
c               fbaso.f
c               fbasd.f
c
c**********************************************************************
c
      program fmatrx
c
      include 'stddim.inc'
      include 'stdio.inc'
      include 'eprmat.inc'
      include 'eprdat.inc'
      include 'indexf.inc'
      include 'fnames.inc'
      include 'rndoff.inc'
c
      integer i,j,k,m,n,jcol,kcol
      double precision zr,zi
c
c#####################################################################
c
      write (luttyo,1000)
      write (luttyo,1010)
c
c---------------------------------------------------------------------
c     get file identifier and construct file names
c---------------------------------------------------------------------
c
      call getids(n,1)
c
      fileid=files(1)      
      ips=idxps(1)
      call setnam
c
c---------------------------------------------------------------------
c     read in data from parameter file
c     and build list of basis indices
c---------------------------------------------------------------------
c
      call rdfdat(prname,ierr)
      if (ips.ne.0) then
        call fbaso(ixname)
      else
        call fbasd(ixname)
        do 50 i=1,ndim
          l1(i)=dl1(i)
          jk1(i)=djk1(i)
          k1(i)=dk1(i)
          jm1(i)=djqe1(i)
          m1(i)=dm1(i)
          pi1(i)=dpi1(i)
 50       qi1(i)=dqi1(i)
      end if
c
c---------------------------------------------------------------------
c     read in matrix
c---------------------------------------------------------------------
c
      open (unit=ludisk,file=mtname,status='old',
     #     access='sequential',form='unformatted')
c
      read (ludisk) (zdiag(1,i),zdiag(2,i),i=1,ndim)
      read (ludisk) (jzmat(i),i=1,ndim+1) 
      read (ludisk) (izmat(i),zmat(i),i=1,nelim)
      read (ludisk) (kzmat(i),i=1,ndim+1)
      read (ludisk) (izmat(mxel-i+1),zmat(mxel-i+1),i=1,nelre)
c
      close (unit=ludisk)
c
      write (luttyo,2002) ndim,nelim,nelre,nelim+nelre
c
c---------------------------------------------------------------------
c     write out upper half of matrix
c---------------------------------------------------------------------
c
      open (unit=lulog,file=mfname,status='unknown',
     #     access='sequential',form='formatted')
      write (lulog,1000)
      write (lulog,1040) mfname(:namlth)
      write (lulog,2002) ndim,nelim,nelre,nelim+nelre
c
      j=1
      k=1
c
      do 100 m=1,ndim
        write (lulog,1050) m,l1(m),jk1(m),k1(m),jm1(m),m1(m),
     #                     pi1(m),qi1(m)
        if ((abs(zdiag(1,m)).gt.rndoff).or.
     #      (abs(zdiag(2,m)).gt.rndoff)) then
          write (lulog,1060) m,zdiag(1,m),zdiag(2,m),
     #          l1(m),jk1(m),k1(m),jm1(m),m1(m),pi1(m),qi1(m)
        endif
c
        if (jzmat(m).ne.jzmat(m+1)) then
          jcol=izmat(jzmat(m+1)-1)
        else
          jcol=m
        end if
c
        if (kzmat(m).ne.kzmat(m+1)) then
          kcol=izmat(mxel-kzmat(m+1)+2)
        else
          kcol=m
        end if
c
        do 110 n=m+1,max(jcol,kcol)
        if ((n.le.jcol).and.(n.eq.izmat(j))) then
          zi=zmat(j)
          j=j+1
        else
          zi=0.0D0
        endif
        if ((n.le.kcol).and.(n.eq.izmat(mxel-k+1))) then
          zr=zmat(mxel-k+1)     
          k=k+1
        else
          zr=0.0D0
        endif
c
        if ((abs(zr).gt.rndoff).or.(abs(zi).gt.rndoff)) then
          write (lulog,1060) n,zr,zi,
     #          l1(n),jk1(n),k1(n),jm1(n),m1(n),pi1(n),qi1(n)
        endif
c
 110    continue
c
        if ((j.ne.jzmat(m+1)).or.(k.ne.kzmat(m+1))) then
        write (lulog,2000)
        stop
      endif
c
 100  continue
c
c---------------------------------------------------------------------
c                  exit program
c---------------------------------------------------------------------
c
      write (luttyo,1000)
      write (lulog,1000) 
c
      close (unit=lulog)        
c
      stop
c
c=====================================================================
c     format statements
c=====================================================================
c
 1000 format (/,70('#'),/)
 1010 format (25x,'PROGRAM : FMATRX',/,25x,'----------------',/)
 1040 format (/,10x,'matrix elements from file : ',a)
 1050 format (//,11x,'*** Row : ',i5,' ***',11x,'<',6(i3,','),i3,'|',
     #        /,3x,'Col',3x,'Real Part',6x,'Imaginary Part',6x,
     #        'L  jK   K  jqM  M  pI  qI',/)
 1060 format (1x,i5,' (',g14.7,',',g14.7,')   ',
     # '|',6(i3,','),i3,'>')
c
 2000 format (//,15x,'*** OOPS!, MATRIX FILE CORRUPTED ***',//)
 2002 format(/10x,'Matrix dimension: ',i6/
     #        10x,'Off-diagonal elements: ',i7,' imaginary'/
     #        33x,i7,' real'/33x,i7,' total'/)
c
c=====================================================================
c
      end 
