c----------------------------------------------------------------------
c                   =========================
c                      common block FNAMES
c                   =========================
c
c Common block for all the filenames that may possible be associated
c with a given file i.d.  The filenames are defined as follows:
c 
c prname : <fileid>.PAR?   Parameter file (unformatted)
c fmname : <fileid>.FMT?   Parameter listing (formatted)
c bsname : <fileid>.BSS?   Basis set indices
c spname : <fileid>.SPC?   Calculated spectrum
c rlname : <fileid>.RLF?   Data from swept-field CG calculation
c tdname : <fileid>.TDL?   Tridiagonal SLE matrix (unformatted)
c tfname : <fileid>.TDF?   Tridiagonal SLE matrix (formatted)
c mtname : <fileid>.MTX?   SLE matrix (unformatted)
c mfname : <fileid>.MTF?   SLE matrix (formatted)
c ixname : <fileid>.IND?   basis set index list (unformatted)
c vtname : <fileid>.STV?   Starting vector
c tsname : <fileid>.MTS?   MTS database file
c egname : <fileid>.EGV?   SLE eigenvalues/weights
c evname : <fileid>.EVC?   SLE eigenvectors (unformatted)
c efname : <fileid>.EFV?   SLE eigenvectors (formatted)
c ername : <fileid>.ERR?   Error estimates in CG procedure
c dename : <fileid>.DEV?   Distinctive eigenvalues
c 
c ? specifies pS=0 (z) subspace or pS=+/-1 (x,y) subspace
c   o means the backup files for storing unpruned basis set
c
c----------------------------------------------------------------------
c
      integer mxlth
      parameter(mxlth=30)
c
      character*30 fileid,prname,fmname,bsname,spname,rlname,tdname,
     #             tfname,mtname,mfname,vtname,tsname,egname,evname,
     #             efname,egnamv,evnamv,vtnamv,ername,dename,ixname,
     #             prnamo,ixnamo
c
      logical nameOK
      integer namlth
c
      common /fnames/ nameOK,namlth,fileid,prname,fmname,bsname,
     #                spname,rlname,tdname,tfname,mtname,mfname,
     #                vtname,tsname,egname,evname,efname,egnamv,
     #                evnamv,vtnamv,ername,dename,ixname,
     #                prnamo,ixnamo
c
      character*30 files
      character*5 flags
      integer idxps
c
      common /filcom/ files(mxcalc),idxps(mxcalc),flags(mxcalc)
c
      logical recflg,stmflg,stvflg,tdlflg,evalflg,evecflg,tstflg,lstflg
c
      common /flgcom/ recflg,stmflg,stvflg,tdlflg,evalflg,evecflg,
     #                tstflg,lstflg
