      subroutine four1(data,nn,isign)
c*********************************************************************
c     This subroutine performs complex fast Fourier transform with
c     double precision.  It replaces dffcf routine in imsl library.
c            data  :  array of length nn
c            nn    :  integer which is power of 2
c            isign :  input for direction of fft
c
c     This is based on the same program in Numerical Recipes.
c*********************************************************************
c
      implicit none
c
      integer isign,nn,i,istep,j,m,mmax,n
      double precision data(2*nn),tempi,tempr,theta,
     #                 wi,wpi,wpr,wr,wtemp
c
c#####################################################################
c
c     reduce the intensity of the first data points by half for
c     baseline correction
c
      data(1)=data(1)*0.5D0
      data(2)=data(2)*0.5D0
c
      n=2*nn
      j=1
      do 11 i=1,n,2
         if (j.gt.i) then
            tempr=data(j)
            tempi=data(j+1)
            data(j)=data(i)
            data(j+1)=data(i+1)
            data(i)=tempr
            data(i+1)=tempi
         end if
         m=n/2
 1       if ((m.ge.2).and.(j.gt.m)) then
            j=j-m
            m=m/2
            go to 1
         end if
         j=j+m
 11   continue
      mmax=2
 2    if (n.gt.mmax) then
         istep=2*mmax
         theta=6.28318530717959D0/(isign*mmax)
         wpr=-2.D0*dsin(0.5D0*theta)**2
         wpi=dsin(theta)
         wr=1.D0
         wi=0.D0
         do 13 m=1,mmax,2
            do 12 i=m,n,istep
               j=i+mmax
               tempr=wr*data(j)-wi*data(j+1)
               tempi=wr*data(j+1)+wi*data(j)
               data(j)=data(i)-tempr
               data(j+1)=data(i+1)-tempi
               data(i)=data(i)+tempr
               data(i+1)=data(i+1)+tempi
 12         continue
            wtemp=wr
            wr=wr*wpr-wi*wpi+wr
            wi=wi*wpr+wtemp*wpi+wi
 13      continue
         mmax=istep
         go to 2
      end if
      return
      end
