c----------------------------------------------------------------------
c                    =========================
c                       subroutine GETIDS
c                    =========================
c
c  Returns a list of filenames in array <files> in common /filcom/
c  Optionally uses UNIX command line parameter convention
c
c          n        ; # of files
c          narg     ; # of arguments
c
c  Uses :
c	   whris.f  ;  subroutine that replaces index (Unix command)
c----------------------------------------------------------------------
      subroutine getids(n,limit)
c
      implicit none
c
      integer n,limit
c
      include 'stddim.inc'
      include 'stdio.inc'
      include 'fnames.inc'
c
c...............................................
c Code between dotted lines is intended for 
c running these programs in a UNIX environment
c
      integer i,idot,iend,ineg,narg
      character*30 args
      character*5 deflag
c
      integer iargc,whris
      external iargc,getarg,whris
c
      deflag='     '
      narg=iargc()
c
      n=0
c
      if (narg.gt.0) then
         do 5 i=1,narg
         call getarg(i,args)
         idot=whris(args,'.')
         ineg=whris(args,'-')
         if (idot.ge.1) then
             n=n+1
             files(n)=args
             flags(n)=deflag
             if (n.eq.limit) go to 20
         else if (ineg.eq.1) then
             deflag=args(2:6)
         else
             write(luttyo,1010)
             call exit
         end if
 5       continue
      else
c..................................................
c
 10     n=n+1
 15     write (luttyo,1020)
        read (luttyi,1025,err=15) files(n)
        if (files(n).eq.' ') then
            n=n-1
            go to 20
        end if
 25     read (luttyi,1030,err=15) deflag
        ineg=whris(deflag,'-')
        if (ineg.eq.1) then
            flags(n)=deflag(2:5)
        else if (ineg.eq.0) then
            flags(n)=deflag(1:5)
        else
            write (luttyo,1040)
            go to 25
        end if
c 
        if (n.lt.limit) go to 10
c..................................................
      end if
 20   do 30 i=1,n
        fileid=files(i)
        idot=whris(fileid,'.')
c
        if( (fileid(idot+1:idot+1).eq.'x').or.
     #      (fileid(idot+1:idot+1).eq.'X').or.
     #      (fileid(idot+1:idot+4).eq.'parx')) then
           idxps(i)=1
        else if( (fileid(idot+1:idot+1).eq.'y').or.
     #      (fileid(idot+1:idot+1).eq.'Y').or.
     #      (fileid(idot+1:idot+4).eq.'pary')) then
           idxps(i)=-1
        else if( (fileid(idot+1:idot+1).eq.'z').or.
     #      (fileid(idot+1:idot+1).eq.'Z').or.
     #      (fileid(idot+1:idot+4).eq.'parz')) then
           idxps(i)=0
        else
           write (luttyo,1050)
        end if
        files(i)=fileid(:idot-1)
 30   continue
c..................................................
c
      return
c
c######################################################################
c  Format statements
c######################################################################
c
 1010 format(2x,' *** Needs extension for pS indices *** ',/,
     #       9x,'.x <==> pS=1 ; .y <==> pS=-1 ; .z <==> pS=0')
 1020 format(2x,'Enter file id with extension (<CR> to end): ',/,
     #       9x,'.x <==> pS=1 ; .y <==> pS=-1 ; .z <==> pS=0')
 1025 format(a)
 1030 format(2x,'Enter flags :  d or <CR> for default flags',/,
     #       17x,'r <--> read .mtx? & .stv? files',/,
     #       17x,'m <--> write .mtx? file',/,
     #       17x,'v <--> write .stv? file')
 1040 format(2x,' *** Not a valid flag ***',/)
c
 1050 format(2x,' *** Not a valid file extension ***',/)
c
      end
