c*********************************************************************
c
c                       ================
c                       PROGRAM : SNGLQD
c                       ================
c
c This program generates single quadrature signal in time domain in
c complex*8 format
c
c       Includes :
c               stdio.inc
c
c       Uses :
c
c*********************************************************************
c
      program snglqd
c
      implicit none
c
      include 'stdio.inc'
c
      logical fexist
c
      character*30 namei,nameo
      integer i,j,ierr,iend,npt1,npt2
      complex*16 xd(512,512)
      complex*8 xs(512,512)
c
      integer whris
      external whris
c
c#####################################################################
c
      write (luttyo,1000)
      write (luttyo,1010)
c
 15   write (luttyo,1020)
      read (luttyi,1025,err=15) namei
 25   write (luttyo,1030)
      read (luttyi,1025,err=25) nameo
      write (luttyo,1050)
      read (luttyi,*) npt1,npt2
c
c---------------------------------------------------------------------
c     construct file names
c---------------------------------------------------------------------
c
      iend=whris(namei,' ')-1
      namei=namei(:iend)//'.fid'
      iend=whris(nameo,' ')-1
      nameo=nameo(:iend)//'.dat'
c
      inquire(file=namei,exist=fexist)
      if (fexist) then
         open (unit=ludisk,file=namei,status='old',
     #         access='sequential',form='unformatted')
         do 30 j=1,npt2
 30         read(xd(i,j),i=1,npt1)
         close (unit=ludisk)
      else
         write (luttyo,1100) namei
         go to 999
      end if
c
      do 50 j=1,npt2
      do 50 i=1,npt1
 50      xs(i,j)=dconjg(xd(i,j))

      open (unit=ludisk,file=nameo,status='unknown',
     #      access='sequential',form='unformatted')
      do 120 j=1,npt2
 120     write (ludisk) (xs(i,j),i=1,npt1)
c
 999  continue
      stop
c
c=====================================================================
c     format statements
c=====================================================================

c
 1000 format(/,2x,70('#'),/)
 1010 format(25x,'PROGRAM : SNGLQD',/,25x,'----------------')
 1020 format(2x,'Enter file id of the fid file : ',$)
 1025 format(a)
 1030 format(2x,'Enter file id of the output data file : ',$)
 1050 format(2x,'# of data points [npt1,npt2] : ',$)
 1100 format(/,20x,'*** CANNOT FIND FILE ',a,' ***',/)
c
c=====================================================================
c
      end
