c----------------------------------------------------------------------
c                    =====================
c                     subroutine TDSNAM
c                    =====================
c
c Given a generic name in <fileid>, this subroutine removes any
c file extension from <fileid> and determines the names for the
c various possible output files associated with 2-D experiments.
c
c  Includes
c      tdfnam.inc   Definition of names in common /tdfnam/
c
c  NB: Although the code in namdef.inc and this routine are standard
c      FORTRAN 77, they may not be portable to installations that
c      do not fully implement the standard.
c
c----------------------------------------------------------------------
      subroutine tdsnam
c
      implicit none
c
      include 'tdexp.inc'
      include 'tdfnam.inc'
c
      integer iendio,ienddt,whris
      external whris
c
      iendio = whris(ioflid , ' ' )-1
      ienddt = whris(dtflid , ' ' )-1
c
      ipname=ioflid(:iendio)//'.inp'
      rpname=ioflid(:iendio)//'.trm'
      mgname=ioflid(:iendio)//'.mag'
      fidnam=ioflid(:iendio)//'.fid'
      gibnam=ioflid(:iendio)//'.gib'
      datnam=ioflid(:iendio)//'.dat'
      if (imag.eq.1) mgname=dtflid(:ienddt)//'.mag'
      if (imag.eq.1) gibnam=dtflid(:ienddt)//'.gib'
      prjnam=dtflid(:ienddt)//'.prjz'
      prnamx=dtflid(:ienddt)//'.parx'
      prnamz=dtflid(:ienddt)//'.parz'
      ixnamx=dtflid(:ienddt)//'.indx'
      vtnamx=dtflid(:ienddt)//'.stvx'
      egnamx=dtflid(:ienddt)//'.egvx'
      egnamy=dtflid(:ienddt)//'.egvy'
      egnamz=dtflid(:ienddt)//'.egvz'
      egnamo=dtflid(:ienddt)//'.egvo'
      evnamx=dtflid(:ienddt)//'.evcx'
      evnamy=dtflid(:ienddt)//'.evcy'
      evnamz=dtflid(:ienddt)//'.evcz'
      evnamo=dtflid(:ienddt)//'.evco'
      nameOK=.true.
      namlth=iendio+4
      nmlth1=namlth+1
      return
      end
