c*********************************************************************
c
c                       ================
c                       PROGRAM : EGL2P
c                       ================
c
c       This program converts the format of the eigenvalue files
c       from cw EPRLL calculation to 2D EPRP format.
c
c       Uses :
c               getids.f
c*********************************************************************
c
      program egl2p
c
      implicit none
      include 'stddim.inc'
      include 'stdio.inc'
      include 'fnames.inc'
c
      integer i,n,ncalc,iend,whris,nev,ioerr
c
      double precision field,ai(1000)
      complex*16 ci,a1(1000),a2(1000)
      parameter (ci=(0.0d0,1.0d0))
c
      external whris
c
c#####################################################################
c
      call getids(n,10)
c
      write (luttyo,10)
 10   format (2x,'Enter the magnetic field : ')
      read (luttyi,*) field
c
c======================================================================
c     loop over calculations
c======================================================================
c
      do 900 ncalc=1,n
c
c---------------------------------------------------------------------
c     construct file names
c---------------------------------------------------------------------
c
        fileid = files(ncalc)
        iend = whris(fileid,' ')-1
        egname=fileid(:iend)//'.egv'
        evname=fileid(:iend)//'.egvx'
c
c----------------------------------------------------------------------
c     open cw eigenvalue file and read
c----------------------------------------------------------------------
c
        open (unit=ludisk,file=egname,status='old',
     #     access='sequential',form='formatted',iostat=ioerr)
        nev=1
 30     read (ludisk,'(5(g14.7,1x))',end=32) ai(nev),a1(nev),a2(nev)
        a1(nev)=a1(nev)-field*ci
        nev=nev+1
        go to 30
 32     close (unit=ludisk)
        nev=nev-1
c
c----------------------------------------------------------------------
c     write eigenvalues in 2D format
c----------------------------------------------------------------------
c
        open (unit=ludisk,file=evname,status='unknown',
     #        access='sequential',form='formatted')
        write (ludisk,2200) (i,i,a1(i),a2(i),i=1,nev)
 2200   format(i4,2x,i4,4x,g14.7,',',g14.7,2x,g14.7,',',g14.7)
        close (unit=ludisk)
 900  continue
c
      stop
      end
