c***********************************************************************
c
c                       ==============
c                       program FSTVEC
c                       ==============
c
c       This program will read in the starting vector data file 
c       written by eprlf, eprcgf, eprcgl and epresa.
c       Write it to the screen in an understandable form.
c
c       Includes:
c               stddim.inc
c               stdio.inc
c               eprdat.inc
c               indexf.inc
c               fnames.inc
c               rndoff.inc
c
c       Uses:
c               getids.f
c               setnam.f
c               rdfdat.f
c               fbaso.f
c               fbasd.f
c               zdotu.f
c
c***********************************************************************
c
      program fstvec
c
      include 'stddim.inc'
      include 'stdio.inc'
      include 'eprdat.inc'
      include 'indexf.inc'
      include 'fnames.inc'
      include 'rndoff.inc'
c
      integer i,j,ierr
      double precision x(2,mxdim)
      complex*16 psnorm,zdotu
      external zdotu
c
c######################################################################
c
      write (luttyo,1000)
      write (luttyo,1010)
c
c----------------------------------------------------------------------
c     get file identifier and construct file names
c----------------------------------------------------------------------
c
      call getids(n,1)
c
      fileid=files(1)
      ips=idxps(1)
c
      call setnam
c
c----------------------------------------------------------------------
c     read in data from parameter file
c----------------------------------------------------------------------
c
      call rdfdat(prname,ierr)
c
      if (ips.ne.0) then
        call fbaso(ixname)
      else
        call fbasd(ixname)
        do 50 i=1,ndim
          l1(i)=dl1(i)
          jk1(i)=djk1(i)
          k1(i)=dk1(i)
          jm1(i)=djqe1(i)
          m1(i)=dm1(i)
          pi1(i)=dpi1(i)
 50       qi1(i)=dqi1(i)
      end if
c       
c----------------------------------------------------------------------
c     read in vector
c----------------------------------------------------------------------
c
      open (unit=ludisk,file=vtname,status='old',
     #     access='sequential',form='unformatted')
      read (ludisk) (x(1,i),x(2,i),i=1,ndim)
      close (unit=ludisk)
c
c----------------------------------------------------------------------
c     write out elements of starting vector
c----------------------------------------------------------------------
c
      write (luttyo,1000)
      write (luttyo,1020) vtname(:namlth)
      psnorm=zdotu(x,x,ndim)
      write (luttyo,1030) psnorm
      write (luttyo,1050) 
c
      do 20 i=1,ndim
        if (abs(x(1,i)).gt.rndoff .or. abs(x(2,i)).gt.rndoff) 
     #   write (luttyo,1060) i,x(1,i),x(2,i),
     #        l1(i),jk1(i),k1(i),jm1(i),m1(i),pi1(i),qi1(i)
 20   continue
c
c----------------------------------------------------------------------
c     exit program
c----------------------------------------------------------------------
c
      write (luttyo,1000)
      stop
c
c======================================================================
c     format statements
c======================================================================
c
 1000 format (/,70('#'),/)
 1010 format (25x,'PROGRAM : FSTVEC',/,25x,'----------------')
 1020 format (/,10x,'starting vector elements from file : ',a)
 1030 format (/,5x,'pseudonorm of starting vector = (',g13.6,',',
     #        g13.6,')')
 1050 format (//,3x,'Row',3x,'Real Part',6x,'Imaginary Part',6x,
     #        'L  jK   K  jM   M  pI  qI',/)
 1060 format (1x,i5,' (',g14.7,',',g14.7,')   ',
     # '|',6(i3,','),i3,'>')

c
c======================================================================
c
      end 
