c**********************************************************************
c       
c                       ===================
c                       SUBROUTINE : RDFINP
c                       ===================
c
c       NOTE: This is the EPRTD version of subroutine RDFDAT.
c
c       This writes the parameters contained in the common block
c       defined in tdexp.inc into a file in a form that can be read 
c       by rdfdat.f. 
c
c       Notes:
c               Care should be taken to ensure that the common 
c               block definition in the include file tdexp.inc
c               is consistent with the information stored in the
c               disk files by this routine to avoid corrupting 
c               the parameter file.
c
c       Includes:
c               stdio.inc
c               tdexp.inc
c
c**********************************************************************
c
      subroutine rdfinp(ipname)
c
      include 'stdio.inc'
      include 'tdexp.inc'
c
      character*30 ipname
      integer i
c
c######################################################################
c
c----------------------------------------------------------------------
c     open parameter file
c----------------------------------------------------------------------
c
      open (unit=ludisk,file=ipname,access='sequential',
     #      form='formatted')
c
      do 10 i=1,6
 10      read (ludisk,*)
c
      read (ludisk,*) iexp
      read (ludisk,*) 
      read (ludisk,*) icomb
      read (ludisk,*) npt1,npt2
      read (ludisk,*) idtf,ispc
      if (idtf.eq.0) then
          read (ludisk,*) init1,stpt1,init2,stpt2
      else if (idtf.eq.1) then
          read (ludisk,*) init1,stpt1,inif2,finf2
      else
          read (ludisk,*) inif1,finf1,inif2,finf2
      end if
      if (iexp.gt.2) read (ludisk,*) tfix
      read (ludisk,*) ndim1
      if (iexp.lt.3) then
        read (ludisk,*) nev1
      else
        read (ludisk,*) nev1,nev0
      end if
      read (ludisk,*) inz
      read (ludisk,*) field
c
      read (ludisk,*) gib0,gib2
      read (ludisk,*) lwid
c
c----------------------------------------------------------------------
c     close parameter file
c----------------------------------------------------------------------
c
      close (unit=ludisk)
c
      return
c
      end
