c*********************************************************************
c
c                       ==================
c                       SUBROUTINE : STVEC
c                       ==================
c
c       This program returns the starting vector according the option
c       user specified.
c
c	29-DEC-92 Sanghyuk Lee
c
c       Includes :
c               stddim.inc
c               stdio.inc
c               eprdat.inc
c               fnames.inc
c               indexf.inc
c
c       Uses :
c               stvecp.f
c		znormu.f
c
c*********************************************************************
c
      subroutine stvec(stv,b,eval,evec,evdim,mdf)
c
      implicit none
c
      include 'stddim.inc'
      include 'stdio.inc'
      include 'eprdat.inc'
      include 'fnames.inc'
      include 'indexf.inc'
c
      logical fexist    
c
      integer i,j,k,evdim,mdf,ierr,nt1
      double precision cfact,t1,ratio
c
      complex*16 czero,ci,cnorm,znormu
      parameter (czero=(0.0D0,0.0D0),ci=(0.0D0,1.0D0))
c
      complex*16 y,v1,w,eval,evec,stv,b
      dimension stv(evdim,*),b(evdim),y(mxdim),v1(mxnev),
     #          eval(evdim),evec(evdim,*)
c
      external znormu
c
c#####################################################################
c
      cfact=1.760844783D1
c
      if (ips.ne.0) then
c
c---------------------------------------------------------------------
c     calculate starting vector for off-diagonal space
c---------------------------------------------------------------------
c
        call stvecp(stv(1,1))
c
      else
c       
c----------------------------------------------------------------------
c     calculate t1-dependent starting vectors for diagonal space
c----------------------------------------------------------------------
c
        if (mdf.eq.0) then
c                    *** read the starting vector : pS=1 ***
          open (unit=ludisk,file=vtnamv,status='old',
     #          access='sequential',form='unformatted')
          read (ludisk) (b(i),i=1,ndimo)
          close (unit=ludisk)
c                    *** read the eigenvalues : pS=1 ***
          open (unit=ludisk,file=egnamv,status='old',
     #          access='sequential',form='formatted')
          read (ludisk,2520) (j,k,eval(i),w,i=1,nevo)
          close (unit=ludisk)
c                    *** substract b0 term from the eigenvalues ***
          do 10 i=1,nevo
 10         eval(i)=(eval(i)+ci*b0)*cfact
c                    *** read the eigenvectors : pS=1 ***
c
          open (unit=ludisk,file=evnamv,status='old',
     #         access='sequential',form='unformatted')
          do 12 j=1,nevo
 12         read (ludisk) (evec(i,j),i=1,ndimo)
          close (unit=ludisk)
        end if
c
        do 14 i=1,nevo
        y(i)=czero
        do 14 j=1,ndimo
 14       y(i)=y(i)+evec(j,i)*b(j)
c
        do 100 nt1=1,nstp
          t1=dfloat(int1+(nt1-1)*stt1)*1.0D-3
          do 16 i=1,nevo
 16         v1(i)=cdexp(-eval(i)*t1)
c
          do 18 i=1,ndimo
            cnorm=czero
            do 19 j=1,nevo
 19           cnorm=cnorm+evec(i,j)*v1(j)*y(j)
              stv(i,nt1)=cnorm
 18       continue
 100    continue
c
c----------------------------------------------------------------------
c   ** only for the routines that need a single starting vector **
c     convert the evolved density matrices into the diagonal subspace
c     using the pulse propagator, and take linear combination of the
c     first five in the ratio of 3:2:2:2:1.  This ratio is purely
c     empirical.
c----------------------------------------------------------------------
c
        if (itype.ne.4) then
c
           do 40 nt1=1,nstp
              j=ndim+1
              do 42 i=ndimo,1,-1
              do 42 k=1,pid(i)
                 j=j-1
                 stv(j,nt1)=pp(j)*stv(i,nt1)
 42           continue
c
              do 44 i=1,ndim
                 if (nt1.eq.5) stv(i,1)=0.3*stv(i,1)+0.2*stv(i,2)+
     #	             0.2*stv(i,3)+0.2*stv(i,4)+0.1*stv(i,5)
 44           continue
 40        continue
c
           cnorm=znormu(stv(1,1),ndim)
           do 46 i=1,ndim
 46           stv(i,1)=stv(i,1)/cnorm
c
    
        else if (lstflg.and.(itype.eq.4)) then
c
           nstp=1
           do 54 i=1,ndimo
              stv(i,1)=0.3*stv(i,1)+0.2*stv(i,2)+
     #             0.2*stv(i,3)+0.2*stv(i,4)+0.1*stv(i,5)
 54        continue
c     
	end if
c
      end if
c
      do 60 i=1,ndim
 60      b(i)=stv(i,1)
c
      return
c
c=====================================================================
c     format statements
c=====================================================================
c
 2520 format(i4,2x,i4,4x,g14.7,1x,g14.7,2x,g14.7,1x,g14.7)
c
c----------------------------------------------------------------------
      end

