c*********************************************************************
c
c                       ================
c                       PROGRAM : SCSPEC
c                       ================
c
c       This program scales the 2D spectrum according to the user-
c       specified scaling factor.
c
c*********************************************************************
c
      program scspec
c
      implicit none
c
      include 'stdio.inc'
      logical fexist
      character name1*30,name2*30,xaxisf*30,yaxisf*30
      integer i,j,npt1,npt2,ndata,lth,whris
      double precision inif1,res1,inif2,res2,fdstep,amin,amax
      double precision spec(256,256),scale
c
      data xaxisf/'f2 (MHz)'/
      data yaxisf/'f1 (MHz)'/
c
c#####################################################################
c
      write (luttyo,1000)
      write (luttyo,1010) 
c
 15   write (luttyo,1020)
      read (luttyi,1025,err=15) name1
 25   write (luttyo,1030)
      read (luttyi,1025,err=25) name2
c
      write (luttyo,1040)
      read (luttyi,*) scale
c
      inquire(file=name1,exist=fexist)
      if (fexist) then
c
         open (unit=ludisk,file=name1,status='old',
     #        access='sequential',form='formatted')
         read (ludisk,*)
         read (ludisk,2110) npt2
         read (ludisk,2110) npt1
         read (ludisk,2120) inif2,res2,inif1,res1,amin,amax
         read (ludisk,2130) ((spec(i,j),j=1,npt2),i=1,npt1)
         close (unit=ludisk)
      else
         write (luttyo,1050)
         call exit
      end if
c
c-----------------------------------------------------------------------
c     Scale the spectrum and output scaled spectrum
c-----------------------------------------------------------------------
c
      do 100 j=1,npt2
      do 100 i=1,npt1
  100    spec(i,j)=spec(i,j)*scale
c
      amin=amin*scale
      amax=amax*scale
c
      open(unit=ludisk,file=name2,status='unknown',
     #     access='sequential',form='formatted')
      write (ludisk,3100) 0
      write (ludisk,3110) npt2,1,npt2,xaxisf
      write (ludisk,3110) npt1,1,npt1,yaxisf
      write (ludisk,3120) inif2,res2,inif1,res1,amin,amax
      write (ludisk,3120) ((spec(i,j),j=1,npt2),i=1,npt1)
      close (unit=ludisk)
c
      stop
c
c=====================================================================
c     format statements
c=====================================================================
c
 1000 format(//,2x,70('#'),//)
 1010 format(25x,'PROGRAM : SCSPEC',/,25x,'---------------',//)
 1020 format(2x,'Enter full name of input file : ')
 1025 format(a)
 1030 format(2x,'Enter full name of output file : ')
 1040 format(2x,'Enter scale factor : ')
 1050 format(2x,'** No such file **')
c
 2110 format(i10)
 2120 format(6e10.4)
 2130 format(8e10.4)
c
 3100 format(i10)
 3110 format(3i10,5x,a30)
 3120 format(8e10.4)
c
c=====================================================================
c
      end
