c----------------------------------------------------------------------
c                    =========================
c                         common PARCOM
c                    =========================
c
c     Common block containing a list of quantities associated with
c     each of the fitting parameters being varied (i.e. each parameter
c     in the x array for LMDER-family programs).
c
c     NOTE: the file 'nlsdim.inc' must be included before this file.
c
c prmax  : Vector containing upper limits for each parameter in x array
c prmin  : Vector containing lower limits for each parameter in x array
c prscl  : Vector containing desired absolute accuracy for each parameter
c          in x array
c xfdstp : Vector containing size of forward-difference step for each
c          parameter in x array
c xerr   : Vector containing uncertainty estimates for each parameter in x
c ibnd   : Flag for boundaries imposed on each parameter:
c          0=none, 1=minimum, 2=maximum, 3=both
c ixpr   : Index of each variable parameter into the fepr array in /eprprm/
c nser   : Number of spectra in the series
c nsparm : Number of series parameters set
c          (should be 8 or 9 before data command)
c nprm   : Number of parameters being varied
c----------------------------------------------------------------------
c
      double precision fparm,prmax,prmin,prscl,xfdstp,xerr,
     #                 stol,sstep,smn,smx,stval
      integer iparm,ixx,ibnd,ixpr,nser,nsparm,nprm,negegv,idebug,
     #                 ievec
      logical gflag,aflag,rotflg,potflg,uniflg,seteval,dataOK
      character*6 tag
      common /parcom/ fparm(nfprm),prmax(mxvar),prmin(mxvar),
     #                prscl(mxvar),xfdstp(mxvar),xerr(mxvar),
     #                stol,sstep,smn,smx,stval,iparm(niprm),
     #                ixx(nfprm),ibnd(mxvar),ixpr(mxvar),nser,
     #                nsparm,nprm,negegv,idebug,ievec,gflag,
     #                aflag,rotflg,potflg,uniflg,seteval,
     #                dataOK,tag(mxvar)
c
